commit 59db34888d289dae8fae2bcbf5e435be53da0edc
Author: H.J. Lu <hjl.tools@gmail.com>
Date:   Thu Jul 3 04:54:39 2025

    x86-64: Add RDI clobber to 64-bit dynamic TLS patterns
    
    *tls_global_dynamic_64_largepic, *tls_local_dynamic_64_<mode> and
    *tls_local_dynamic_base_64_largepic use RDI as the __tls_get_addr
    argument.  Add RDI clobber to these patterns to show it.
    
    gcc/
    
            PR target/120908
            * config/i386/i386.cc (legitimize_tls_address): Pass RDI to
            gen_tls_local_dynamic_64.
            * config/i386/i386.md (*tls_global_dynamic_64_largepic): Add
            RDI clobber and use it to generate LEA.
            (*tls_local_dynamic_64_<mode>): Likewise.
            (*tls_local_dynamic_base_64_largepic): Likewise.
            (@tls_local_dynamic_64_<mode>): Add a clobber.
    
    gcc/testsuite/
    
            PR target/120908
            * gcc.target/i386/pr120908.c: New test.
    
    Signed-off-by: H.J. Lu <hjl.tools@gmail.com>
    (cherry picked from commit d8d5e2a8031e74f08f61ccdd727476f97940c5a6)

diff --git a/gcc/config/i386/i386.cc b/gcc/config/i386/i386.cc
index 94e29fa4321..edb51f2a9b2 100644
--- a/gcc/config/i386/i386.cc
+++ b/gcc/config/i386/i386.cc
@@ -12273,12 +12273,13 @@ legitimize_tls_address (rtx x, enum tls_model model, bool for_mov)
 	  if (TARGET_64BIT)
 	    {
 	      rtx rax = gen_rtx_REG (Pmode, AX_REG);
+	      rtx rdi = gen_rtx_REG (Pmode, DI_REG);
 	      rtx_insn *insns;
 	      rtx eqv;
 
 	      start_sequence ();
 	      emit_call_insn
-		(gen_tls_local_dynamic_base_64 (Pmode, rax, caddr));
+		(gen_tls_local_dynamic_base_64 (Pmode, rax, caddr, rdi));
 	      insns = get_insns ();
 	      end_sequence ();
 
diff --git a/gcc/testsuite/gcc.target/i386/pr120908.c b/gcc/testsuite/gcc.target/i386/pr120908.c
new file mode 100644
index 00000000000..10e5a46d8d4
--- /dev/null
+++ b/gcc/testsuite/gcc.target/i386/pr120908.c
@@ -0,0 +1,16 @@
+/* { dg-do compile { target { lp64 && fpic } } } */
+/* { dg-options "-O2 -fpic -mtls-dialect=gnu -mcmodel=large" } */
+
+extern __thread long bar1;
+long *
+foo1 (void)
+{
+  return &bar1;
+}
+
+static __thread long bar2;
+long *
+foo2 (void)
+{
+  return &bar2;
+}

